package io.reisub.dreambot.cminer.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.input.Mouse;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.magic.Magic;
import org.dreambot.api.methods.magic.Normal;
import org.dreambot.api.methods.tabs.Tab;
import org.dreambot.api.methods.tabs.Tabs;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;
import org.dreambot.api.wrappers.items.Item;

import java.util.List;

public class Superheat extends TaskNode {
    @Override
    public boolean accept() {
        return Inventory.contains(Constants.IRON_ORE) &&
                Magic.canCast(Normal.SUPERHEAT_ITEM) &&
                Util.playerIsIdle();
    }

    @Override
    public int execute() {
        int count = Inventory.count(Constants.IRON_ORE);
        Item ore = Inventory.get(Constants.IRON_ORE);

        if (ore == null) return Calculations.random(250, 400);

        if (!Magic.isSpellSelected() || !Magic.getSelectedSpellName().contains("Superheat")) {
            Magic.castSpell(Normal.SUPERHEAT_ITEM);
            MethodProvider.sleepUntil(() -> Tabs.isOpen(Tab.INVENTORY), Calculations.random(1200, 1500));
        } else {
            MethodProvider.sleep(50, 150);
        }

        ore.interact();
        Util.sleepUntilAnimating();
        MethodProvider.sleepUntil(() -> Inventory.count(Constants.IRON_ORE) < count || Util.playerIsIdle() || Tabs.isOpen(Tab.MAGIC), Calculations.random(1200, 1500));

        if (!Inventory.isFull()) {
            hoverRock();
        }

        return Calculations.random(250, 400);
    }

    private void hoverRock() {
        if (!Mine.getRocks(Constants.IRON_ROCKS_COLOR).isEmpty()) return;

        List<GameObject> rocks = GameObjects.all(gameObject -> gameObject.getName().equals(Constants.ROCKS) &&
                gameObject.getInteractableFrom().contains(Players.localPlayer().getTile()));

        for (GameObject rock : rocks) {
            if (!Util.isLookingAt(rock)) {
                Mouse.move(rock);
                return;
            }
        }
    }
}
