package io.reisub.dreambot.cplanker;

import io.reisub.dreambot.cplanker.tasks.*;
import io.reisub.dreambot.util.CTaskScript;
import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.randomevents.GenieSolver;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.script.Category;
import org.dreambot.api.script.ScriptManifest;

import java.awt.*;

@ScriptManifest(category = Category.MISC, name = "CPlanker", description = "Chops oaks at sawmill, planks and banks at CW.", author = Constants.AUTHOR, version = 1.0)
public class CPlanker extends CTaskScript {
    @Override
    public void onStart() {
        getRandomManager().registerSolver(new GenieSolver(GenieSolver.Skill.HERBLORE));

        getUI().addSkills(Skill.WOODCUTTING);
        getUI().setCustomLines(1);

        addNodes(
                new PickupNest(),
                new Chop(),
                new BuyPlanks(),
                new Teleport(),
                new OpenBank(),
                new Deposit(),
                new GoToSawmill()
        );
    }

    @Override
    public void onPaint(Graphics g) {
        super.onPaint(g);

        int planks = BuyPlanks.planksMade;
        getUI().drawString("Planks made: " + planks + " (" + getUI().getHourlyRate(planks) + " per hour)");
    }
}
