package io.reisub.dreambot.cplanker.tasks;

import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.bank.Bank;
import org.dreambot.api.methods.container.impl.equipment.Equipment;
import org.dreambot.api.methods.container.impl.equipment.EquipmentSlot;
import org.dreambot.api.methods.filter.Filter;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.items.Item;

public class Deposit extends TaskNode {
    @Override
    public boolean accept() {
        return Bank.isOpen()
                && Inventory.isFull();
    }

    @Override
    public int execute() {
        Bank.depositAllExcept("Coins");
        MethodProvider.sleepUntil(() -> Inventory.onlyContains("Coins"), Calculations.random(2000, 3000));

        if (Equipment.getItemInSlot(EquipmentSlot.RING) == null) {
            Filter<Item> ringFilter = item -> item.getName().startsWith("Ring of dueling");

            while (!Inventory.contains(ringFilter)) {
                Bank.withdraw(ringFilter, 1);
                MethodProvider.sleepUntil(() -> Inventory.contains(ringFilter), Calculations.random(3000, 3500));
            }
        }

        return Calculations.random(250, 400);
    }
}
