package io.reisub.dreambot.cshopper.tasks;

import io.reisub.dreambot.cshopper.CShopper;
import io.reisub.dreambot.util.Constants;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.Shop;
import org.dreambot.api.methods.interactive.NPCs;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.NPC;

public class Open extends TaskNode {
    @Override
    public boolean accept() {
        return !Shop.isOpen()
                && !Inventory.isFull()
                && !Hop.shouldHop;
    }

    @Override
    public int execute() {
        NPC trader = NPCs.closest(CShopper.getConfiguration().getTraderName());

        if (trader == null) return 0;

        trader.interact(Constants.TRADE);
        MethodContext.sleepUntil(Shop::isOpen, Calculations.random(6000, 7000));

        return Calculations.random(200, 400);
    }
}
