package io.reisub.dreambot.csmelter;

public enum SmeltingOption {
    GOLD_BAR(new Ingredient("Gold ore"), "Gold bar", 6),
    GOLD_BRACELET(new Ingredient("Gold bar"), "Gold bracelet", 46, "Bracelet mould");

    private final Ingredient[] ingredients;
    private final String endProduct, mould;
    private final int hotkey, maxCraftsPerInventory;

    SmeltingOption(Ingredient[] ingredients, String endProduct, int hotkey, String mould) {
        this.ingredients = ingredients;
        this.endProduct = endProduct;
        this.hotkey = hotkey;
        this.mould = mould;

        int totalIngredientsRequired = 0;

        for (Ingredient i : ingredients) {
            totalIngredientsRequired += i.getAmount();
        }

        if (mould.equals("")) {
            maxCraftsPerInventory = Math.floorDiv(28, totalIngredientsRequired);
        } else {
            maxCraftsPerInventory = Math.floorDiv(27, totalIngredientsRequired);
        }
    }

    SmeltingOption(Ingredient[] ingredients, String endProduct, int hotkey) {
        this(ingredients, endProduct, hotkey, "");
    }

    SmeltingOption(Ingredient ingredient, String endProduct, int hotkey, String mould) {
        this(new Ingredient[]{ingredient}, endProduct, hotkey, mould);
    }

    SmeltingOption(Ingredient ingredient, String endProduct, int hotkey) {
        this(new Ingredient[]{ingredient}, endProduct, hotkey, "");
    }

    public Ingredient[] getIngredients() {
        return ingredients;
    }

    public String[] getIngredientsNames() {
        String[] ingredientNames = new String[ingredients.length];

        for (int i = 0; i < ingredients.length; i++) {
            ingredientNames[i] = ingredients[i].getName();
        }

        return ingredientNames;
    }

    public int getMaxCraftsPerInventory() {
        return maxCraftsPerInventory;
    }

    public String getEndProduct() {
        return endProduct;
    }

    public int getHotkey() {
        return hotkey;
    }

    public String getMould() {
        return mould;
    }
}
