package io.reisub.dreambot.csmelter.tasks;

import io.reisub.dreambot.csmelter.CSmelter;
import io.reisub.dreambot.csmelter.Ingredient;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.bank.Bank;
import org.dreambot.api.methods.widget.Widgets;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.items.Item;
import org.dreambot.api.wrappers.widgets.WidgetChild;

public class DoBank extends TaskNode {
    @Override
    public boolean accept() {
        return Bank.isOpen();
    }

    @Override
    public int execute() {
        if (Inventory.contains(CSmelter.smeltingOption.getEndProduct())) {
            if (Util.getHoverEntry("deposit") == null) {
                if (Inventory.contains(item -> item.getName().endsWith("mould"))) {
                    Item item = Inventory.get(CSmelter.smeltingOption.getEndProduct());
                    Util.addHoverEntry("deposit", item.getDestination().getBoundingBox());
                } else {
                    WidgetChild depositAll = Widgets.getChildWidget(12, 42);
                    if (depositAll != null && depositAll.isVisible()) {
                        Util.addHoverEntry("deposit", depositAll.getRectangle());
                    }
                }
            }

            Bank.depositAllExcept(item -> item.getName().endsWith("mould"));
            if (!MethodProvider.sleepUntil(() -> Inventory.isEmpty() || Inventory.onlyContains(item -> item.getName().endsWith("mould")), Calculations.random(2000, 2500))) return Calculations.random(250, 400);
        }

        String mould = CSmelter.smeltingOption.getMould();
        if (!mould.equals("")) {
            if (!Inventory.contains(mould)) {
                Bank.withdraw(mould, 1);
                if (!MethodProvider.sleepUntil(() -> Inventory.contains(mould), Calculations.random(2000, 2500))) {
                    return Calculations.random(250, 400);
                }
            }
        }

        String[] names = CSmelter.smeltingOption.getIngredientsNames();

        if (CSmelter.smeltingOption.getIngredients().length == 1) {
            Bank.withdrawAll(CSmelter.smeltingOption.getIngredients()[0].getName());
        } else {
            int craftsPerInventory = CSmelter.smeltingOption.getMaxCraftsPerInventory();

            for (Ingredient i : CSmelter.smeltingOption.getIngredients()) {
                if (Inventory.count(i.getName()) < i.getAmount() * craftsPerInventory) {
                    Bank.withdraw(i.getName(), i.getAmount() * craftsPerInventory);
                }
                MethodProvider.sleep(200, 400);
            }
        }

        Util.hover("minimapToFurnace");

        MethodProvider.sleepUntil(() -> Inventory.containsAll(names), Calculations.random(2000, 2500));

        return Calculations.random(250, 400);
    }
}
