package io.reisub.dreambot.csmelter.tasks;

import io.reisub.dreambot.csmelter.CSmelter;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.bank.Bank;
import org.dreambot.api.methods.input.Keyboard;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.walking.impl.Walking;
import org.dreambot.api.methods.widget.Widgets;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;
import org.dreambot.api.wrappers.widgets.WidgetChild;

public class Smelt extends TaskNode {
    private boolean firstTime = true;

    @Override
    public boolean accept() {
        return Inventory.containsAll(CSmelter.smeltingOption.getIngredientsNames())
                && (Bank.isOpen() || Util.playerIsIdle(1400));
    }

    @Override
    public int execute() {
        GameObject furnace = GameObjects.closest("Furnace");
        if (furnace == null) return Calculations.random(250, 400);

        if (Bank.isOpen()) {
            Util.addHoverEntry("minimapToFurnace", furnace.getTile(), true);
            Walking.walk(furnace);
            MethodProvider.sleep(300, 600);
        }

        furnace.interact();
        if (!furnace.getInteractableFrom().contains(Players.localPlayer().getTile())) {
            if (!Util.sleepUntilMoving()) return Calculations.random(250, 400);
        }

        Util.hover("smeltWidget");
        MethodProvider.sleepWhile(() -> furnace.distance() > Calculations.random(2, 4), Calculations.random(10000, 11000));

        if (CSmelter.smeltingOption.getMould().equals("")) {
            if (!firstTime) Keyboard.holdSpace(() -> {
                WidgetChild w = Widgets.getChildWidget(270, 13);
                return (w != null && w.isVisible()) || Players.localPlayer().isAnimating();
            }, Calculations.random(4000, 4500));

            if (!MethodProvider.sleepUntil(() -> {
                WidgetChild w = Widgets.getChildWidget(270, 13);
                return w != null && w.isVisible();
            }, Calculations.random(5000, 5500))) return Calculations.random(250, 400);

            Keyboard.type(CSmelter.smeltingOption.getHotkey(), false, false);
            if (Util.sleepUntilAnimating()) firstTime = false;
        } else {
            if (!MethodProvider.sleepUntil(() -> {
                WidgetChild w = Widgets.getChildWidget(446, CSmelter.smeltingOption.getHotkey());
                return w != null && w.isVisible();
            }, Calculations.random(3000, 3500))) return Calculations.random(250, 400);

            WidgetChild w = Widgets.getChildWidget(446, CSmelter.smeltingOption.getHotkey());
            Util.addHoverEntry("smeltWidget", w.getRectangle());
            w.interact();

            Util.sleepUntilAnimating();
        }

        Util.hover("bank");

        return Calculations.random(250, 400);
    }
}
